;
;	Digitlis hanglejtszs stream-elssel
;
;
;
.org 6639
	.db	0FH,0AH,0,0DDH
	.db	" USR"
	.db	96H,"6659"
	.db	95H,0FFH,0,0,0,0,0	; 20 byte-os fej
;
;
prog:	jp	L1C89			; program kezdete
;
;
;pitch  minta/sec
;4071	7812,5
;4072	8138,0
;4073	8491,8
;4074	8877,8
;4075	9300,6
;4076	9765,6

;ppitch	.dw	00FCFh			; lejtszsi sebessg: 4047 -> 3985 minta/sec (0..4095 pitch rtk a hang IT-hez)
ppitch	.dw	00FE1h			; lejtszsi sebessg: 4065 -> 6300 minta/sec (0..4095 pitch rtk a hang IT-hez)
;ppitch	.dw	00FE7h			; lejtszsi sebessg: 4071 -> 7812 minta/sec (0..4095 pitch rtk a hang IT-hez)
;ppitch	.dw	00FECh			; lejtszsi sebessg: 4076 -> 9765 minta/sec (0..4095 pitch rtk a hang IT-hez)


rd_data	.dw	0000h			; lejtszand adatok tltsi cme
nblokk	.dw	0000h			; lejtszand fjl 8kB-os blokkjainak szma

psave	.db	070h			; P_SAVE mentett rtke (program indulsakor a memrialapozs)
blen	.dw	0000h			; lejtszand blokkhossz
playadr	.dw	0000h			; aktulisan lejtszott mintabjt cme
sample	.dw	0000h			; aktulisan lejtszott mintabjt s bjton belli szmll
;
fstr_FPB
	.db	00h,00h,00h,00h 	; FISH funkcihvs paramterblokkja (IX,HL,DE,BC) (8 bjt)
	.db	00h,00h,00h,00h


;
;
L1C89:	exx
	push	hl			; hasznlt msodlagos regiszterek mentse
	push	bc
	exx
	ld	a,(00003h)		; A reg.= P_SAVE (aktulis memrialapozs)
	ld	(psave),a		; ments a sajt vltozba
;
	xor	a
	ld	(utvonal),a		; tvonal hatrozatlan
p0:	ld	c,0			; GRAPHICS 2
	rst	30h
	.db	4
	ld	bc,0101h
	rst	30h
	.db	35			; CPOS kurzor pozcionlsa:  X=1 Y=1
	ld	bc,mveg-menu
	ld	de,menu			; men kirsa
	rst	30h
	.db	34			; ED_BKOUT blokk krsa kpernyre
p1:	rst	30h
	.db	145			; KBD_CHIN karakter-beolvass billentyzetrl
	ld	a,c
	sub	030h
	jr	c,p1			; ismtls, ha kisebb '0'-nl
	jr	nz,p2
	call	beolvas			; '0' : fjl megnyitsa
	jr	p0
p2:	dec	a
	jr	nz,p3
	call	lejatsz			; '1' : hang lejtszsa
	jr	p0
p3:	dec	a			; '2' : kilps
	jr	nz,p1
;
	ld	a,(psave)		; elmentett P_SAVE vissza A reg.-be
	ld	(0003h),a		; eredeti memrialapozs visszalltsa
	out	(002h),a
	exx
	pop	bc			; hasznlt msodlagos regiszterek visszalltsa
	pop	hl
	exx
	ret				; visszatrs a BASIC-be

;
menu:	.text	"0-Beolvas\220s  1-Lej\220tsz\220s  2-Kil\221p\221s\r\n"
mveg:

;
;
;	Hang megszakts engedlyezse, lejtszs alaphelyzetbe lltsa
;
L1CE5:	call	dint_dis		; lemezvezrl megszak. tllts tiltsa
;
	di				; megszak. tilt	
	ld	hl,00010h		; lejtszs inicializlsa (fejlc 16 bjtjt tlpi)
	ld	(playadr),hl		; adatok kezdete
	ld	hl,00200h		; H = az aktulis adatbjtban htralv mintk szma
	ld	(sample),hl
	ld	hl,(rd_data)		; HL= a betlttt fjl elejnek kezdete a memriban
	ld	de,0005h		; DE= eltols a fejlcben lv pitch rtkhez
	add	hl,de
	ld	a,(hl)			; A reg.= lejtszsi sebessg pitch rtknek fels bjtja
	and	00Fh			; csak az als 4 bit megtartsa
	ld	e,a
	dec	hl
	ld	a,(hl)
	out	(004h),a		; PITCH als 8 bit belltsa
	ld	a,(0B12h)		; A= Port5 tkrkpe
	and	0C0h			; fels 2 bit megtartsa
	or	e			; j PITCH rtk az als 4 bitbe
	or	020h			; hang IT engedlyezse
	ld	(0B12h),a		; j rtk a memriba
	out	(005h),a		; s a portra
	ld	a,00Ah
	out	(070h),a		; CRTC bels regiszternek kivlasztsa (R10)
	ld	a,003h
	or	020h			; kurzor tiltsa
	out	(071h),a		; bels regiszter j rtknek bersa
;
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	hl,L1D32
	ld	(0039h),hl		; ugrutasts clcm bersa
	ei				; megszak. eng.
	ret

;
;
;	Eredeti megszakts visszalltsa
;
L1D0D:	di				; megszak. tilt
	ld	hl,L1D2F		; HL= eredeti megszak. rutin visszalltand kdrszlete
	ld	de,0038h		; DE= megszak. cme
	ld	bc,0003h		; BC= 3 bjt lesz
	ldir				; bjtok msolsa
	ld	a,(0B12h)		; A reg.= Port5 tkrkpe
	res	5,a			; hang IT tiltva
	res	4,a			; hangjel is tiltva
	ld	(0B12h),a		; j rtk a memriba
	out	(005h),a		; s a portra
	ld	a,00Ah			; CRTC R10-es regiszterben a kurzor engedlyezse
	out	(070h),a
	ld	a,003h
	out	(071h),a
	ei				; megszak. eng.
	call	dint_ena		; lemezvezrl megszak. tllts engedlyezse
	ret
;
;	Eredeti megszak. rutin visszalltand kdrszlete
;
L1D2F:	push	af
	ld	a,070h

;
;
;	Sajt megszakts-kiszolgl rutin
;
L1D32:	di				; tovbbi megszak. tilt
	push	af			; A reg. mentse
	ld	a,090h			; memrialapozs: U0,U1,VID,U3
;	ld	a,0B0h			; memrialapozs: U0,U1,U2,U3
	out	(002h),a		; memrialapozs belltsa
	out	(007h),a		; kurzor/hang megszak. krs trlse
	push	hl
	call	L1D47			; hanglejtsz rutin hvsa
	pop	hl
	ld	a,(0003h)		; eredeti memrialapozs vissza
	out	(002h),a
	pop	af			; A reg. vissza
	ei				; megszak. eng
	ret				; visszatrs
;
;
;	Hang lejtszsa (4bit/minta)
;
L1D47:	ld	hl,(sample)
	ld	a,l			; aktulis adatbjt A reg.-be
	dec	h
	jr	nz,L1D5D		; ugrs, ha mg az els mintt kell kiadni
	rlca				; a msodik minthoz ktszer balra kell lptetni az adatbjtot
	rlca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
	or	080h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	hl,(playadr)		; HL-ben az aktulisan jtszott mintabjt cme
	inc	hl			; cm nvelse
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	ld	(playadr),hl
	ld	l,(hl)			; L= a kvetkez 2 mintt tartalmaz bjt
	ld	h,002h			; H= 2 minta van a bjtban
	ld	(sample),hl		; minta jellemzi a sajt vltozba
	ret
;
L1D5D:	rrca				; az els minthoz ktszer jobbra kell lptetni az adatbjtot
	rrca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
	or	080h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	(sample),hl		; frisstett szmll vissza
	ret

;
;	Lemezvezrl megszakts tllts engedlyezse/tiltsa
;
dint_ena:
	ld	d,000h			; D= 000h -> engedlyezs
	jr	dint0
;
dint_dis:
	ld	d,0FFh			; D= 0FFh -> tilts
dint0:	ld	e,02Bh			; E= INT_ENA vltoz sorszma
	ld	b,0FFh			; B= 0FFh -> rs
	ld	hl,0000h
	ld	(fstr_FPB),hl		; FPB:IX - most nem hasznlt
	ld	(fstr_FPB+2),hl		; FPB:HL - most nem hasznlt
	ld	(fstr_FPB+4),de		; FPB:DE - D= j adat  E= vltoz sorszma
	ld	(fstr_FPB+6),bc		; FPB:BC - B=0 olvass, egybknt rs
	ld	de,fstr_FPB		; DE= FPB cme
	ld	c,01Ah			; C = FISH funkci: rendszervltoz beolvassa/rsa
	rst	30h
	.db	219			; FISH funkci hvsa MOPS-on keresztl
	ret

;
;
;	ESC billenty llapotnak beolvassa
;	in: -
;	out:  C - lenyomott billenty ASCII kdja (ESC) vagy 0
;	     ZF - ZF=1 valamelyik vizsgland billentyt lenyomtk
;
L1D7D:	ld	a,(0B11h)		; A reg.= Port3 tkrkpe (billentyzetsor)
	and	0F0h			; fels 4 bit meghagyva
	or	007h			; a 7. sor kivlasztsa	
	ld	(0B11h),a		; j rtk a memriba
	out	(003h),a		; s a portra
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	bit	3,a			; ESC billenty ellenrzse
	ld	c,01Bh			; C= ESC karakterkdja
	ret	z			; visszatrs, ha ESC-et nyomtak
	ld	c,000h			; egybknt C=0 -val tr vissza, ZF=0
	ret

;
;
;	Fjl olvassa s lejtszsa
;
beolvas:ld	de,rdfnev
	ld	hl,utvonal
	ld	bc,fulpath
	call	fk_open
	cp	001h
	ret	nz
lejatsz:ld	de,fulpath		; hangfjl megnyitsa
	rst	30h
	.db	211			; CAS_OPEN
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
	ld	bc,0000h		; eltols= 0000:0000h
	ld	de,0000h
	rst	30h
	.db	216			; fjlmutat belltsa a fjl vghez kpest
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
	sla	d			; fjlmret osztsa 8kB-al (2000h)
	rl	c
	rl	b
	sla	d
	rl	c
	rl	b
	sla	d
	rl	c
	rl	b			; eredmny BC-ben
	ld	a,b			; ellenrzs
	or	c
	jp	z,beolv4		; ugrs, ha 0 az eredmny (hibt nem jelez)
	ld	(nblokk),bc		; blokkokszm mentse a ksbbiekre
	ld	bc,0000h		; eltols= 0000:0000h
	ld	de,0000h
	rst	30h
	.db	214			; fjlmutat belltsa a fjl elejhez kpest
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
;
	di
	ld	a,090h			; j memrialapozs: U0,U1,VID,U3
	ld	(00003h),a		; bellts P_SAVE-be
	out	(002h),a		; s a portra
	ei
;
	ld	hl,04000h		; els 2 blokk beolvassa U1 RAM elejre
	ld	(rd_data),hl
	ex	de,hl			; DE= tltsi cm
	ld	bc,02000h		; BC= beolvasand bjtok (8192)
	ld	(blen),bc		; lejtszand hossz belltsa
	rst	30h
	.db	210			; CAS_BKIN
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
;
	call	L1CE5			; lejtszs alaphelyzetbe lltsa, hang megszakts engedlyezse
;
	ld	hl,06000h		; kvetkez blokk beolvassa U1 RAM kzepre (folytats cirkulrisan)
	ld	(rd_data),hl
	ld	hl,(nblokk)		; HL= 8kB-os blokkok szma
	dec	hl			; cskkents 2-vel
	dec	hl
	ld	b,l			; B= tovbbi beolvasand blokkok szma (most csak max. 255 -> 2MB)
	ld	a,b
	or	a
	jr	z,beolv4		; ugrs, ha 0 lenne a blokkszm
beolv1:	push	bc
	ld	bc,02000h		; BC= beolvasand bjtok (8192)
	ld	(blen),bc		; lejtszand hossz belltsa
	ld	de,(rd_data)		; DE= tltsi cm
	rst	30h
	.db	210			; CAS_BKIN
	or	a
	jr	nz,beolv3		; ugrs, ha hiba volt
;
	ld	bc,08000h		; BC= vidememria kezdete
	ld	de,(rd_data)		; DE= legutbbi tltsi cm
beolv2:	halt				; vrakozs a megszaktsra
	ld	a,(bc)			; kpbjt beolvassa
	cpl
	ld	(bc),a			; invertlt kpbjt visszarsa
	inc	bc
	ld	hl,(playadr)
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	or	a
	sbc	hl,de			; cmek sszehasonltsa
	jr	nz,beolv2		; vrakozs, amg a lejtszs nem tart a legutbb beolvasott adatoknl
	ld	a,020h			; tltsi cm nvelse 8192-vel
	add	a,d
	and	03Fh			; cm fels kt bitje 01b -> U1 RAM cmzse
	or	040h
	ld	d,a
	ld	(rd_data),de		; j tltsi cm mentse
	call	L1D7D			; billentyzet vizsglata
	ld	a,c			; lenyomott gomb ASCII kdja A reg.-be
	pop	bc
	sub	01Bh
	jr	z,beolv4		; ugrs, ha ESC-et nyomtak (ilyenkor A reg.= 0)
	djnz	beolv1
	push	bc
	xor	a			; hibakd trlse
beolv3:	pop	bc
beolv4:	push	af
	call	L1D0D			; megszaktsok helyrelltsra
	rst	30h
	.db	212			; CAS_CLOSE
	pop	af
	or	a
	ret	z			; visszatrs, ha nem volt hiba
;
hibair: ld	h,a			; kirja A reg.-ben adott hibt
	ld	bc,9
	ld	de,hszov
	rst	30h
	.db	34			; ED_BKOUT blokk krsa kpernyre
	ld	a,h
	call	knv
	ld	c,'H'			; 'H' bet kirsa a szm utn
	rst	30h
	.db	33
	rst	30h			; vrakozs billenty lenyomsra
	.db	145			; KBD_CHIN
	ret
;

knv:	ld	l,2			; kirja A reg.-ben adott hexadecimlis szmot
	ld	h,a
	rrca
	rrca
	rrca
	rrca
p14:	and	15
	add	a,48
	cp	58
	jr	c,p15
	add	a,7
p15:	ld	c,a
	rst	30h
	.db	33			; ED_CHOUT  karakterkirs
	ld	a,h
	dec	l
	jr	nz,p14
	ret

;
hszov	.db	"Hiba: A= "
;
rdfnev	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0
utvonal	.db	0
	.db	0 ;92		; \
	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;
#include "lemezkez.asm"
fulpath	.equ	$		; teljes tvonalnv ellltshoz
				; (tfedsben van a lemezkezel halom-terletvel!!!)
;

.end
