;
;	Digitlis hanglejtszs stream-elssel
;
;
;
.org 6639
	.db	0FH,0AH,0,0DDH
	.db	" USR"
	.db	96H,"6659"
	.db	95H,0FFH,0,0,0,0,0	; 20 byte-os fej
;
;
prog:	jp	pmain			; program kezdete
;
;
;pitch  minta/sec
;4071	7812,5
;4072	8138,0
;4073	8491,8
;4074	8877,8
;4075	9300,6
;4076	9765,6

;ppitch	.dw	00FCFh			; lejtszsi sebessg: 4047 -> 3985 minta/sec (0..4095 pitch rtk a hang IT-hez)
ppitch	.dw	00FE1h			; lejtszsi sebessg: 4065 -> 6300 minta/sec (0..4095 pitch rtk a hang IT-hez)
;ppitch	.dw	00FE7h			; lejtszsi sebessg: 4071 -> 7812 minta/sec (0..4095 pitch rtk a hang IT-hez)
;ppitch	.dw	00FECh			; lejtszsi sebessg: 4076 -> 9765 minta/sec (0..4095 pitch rtk a hang IT-hez)


rd_data	.dw	0000h			; lejtszand adatok tltsi cme
nblokk	.dw	0000h			; lejtszand fjl 8kB-os blokkjainak szma
lsblokk	.dw	0000h			; lejtszand fjl utols nem 8kB-os blokkjban lv bjtok szma

psave	.db	070h			; P_SAVE mentett rtke (program indulsakor a memrialapozs)
blen	.dw	0000h			; lejtszand blokkhossz
playadr	.dw	0000h			; aktulisan lejtszott mintabjt cme
sample	.dw	0000h			; aktulisan lejtszott mintabjt s bjton belli szmll
;
progres	.dw	0000h			; a legals sor invertlsnak pozcija
gintpoz	.db	000h			; grafikus megszakts aktulis osztott kperny sorszma

gr_div0	.db	001h,000h,000h,000h,000h,00Fh	; 0. kp videmd, paletta s zr sorszma (15.)
gr_div1	.db	001h,000h,000h,000h,000h,0EFh	; 1. kp videmd, paletta s zr sorszma (239.)

;
fstr_FPB
	.db	00h,00h,00h,00h 	; FISH funkcihvs paramterblokkja (IX,HL,DE,BC) (8 bjt)
	.db	00h,00h,00h,00h


;
;
pmain:	exx
	push	hl			; hasznlt msodlagos regiszterek mentse
	push	bc
	exx
	ld	a,(00003h)		; A reg.= P_SAVE (aktulis memrialapozs)
	ld	(psave),a		; ments a sajt vltozba
;
	di
	ld	a,090h			; j memrialapozs: U0,U1,VID,U3
	ld	(00003h),a		; bellts P_SAVE-be
	out	(002h),a		; s a portra
	ei
;
repeat:	call	kepolv			; kp betltse s megjelentse
	call	lejatsz			; hang lejtszsa
	call	nc,ismet		; vrakozs az ismtls krsre, ha nem volt hiba vagy ESC
	jr	nc,repeat		; ugrs, ha ismtelni kell
;
	ld	c,001h			; 4-szn grafikus md belltsa
	rst	30h
	.db	004h			; VMODE
	ld	a,(psave)		; elmentett P_SAVE vissza A reg.-be
	ld	(0003h),a		; eredeti memrialapozs visszalltsa
	out	(002h),a
	exx
	pop	bc			; hasznlt msodlagos regiszterek visszalltsa
	pop	hl
	exx
	ret				; visszatrs a BASIC-be


;
;
;	Osztott grafikusmd belltsa
;	in:  -
;	out: -
;
setgint:di				; megszak. tilt
	ld	de,gr_div0		; 0. osztott kperny adatainak kitltse
	ld	hl,kerkep+KEPHEAD_TYPE
	ld	a,(hl)			; videmd tmsolsa
	and	KEPTYPE_COLMASK
	ld	(de),a
	inc	hl
	inc	de
	ld	bc,0004h		; paletta tmsolsa
	ldir
;
	ld	de,gr_div1		; 1. osztott kperny adatainak kitltse
	ld	hl,puffer+KEPHEAD_TYPE
	ld	a,(hl)			; videmd tmsolsa
	and	KEPTYPE_COLMASK
	ld	(de),a
	inc	hl
	inc	de
	ld	bc,0004h		; paletta tmsolsa
	ldir
;
	ld	a,000h			; az utols osztott kperny aktivlsa
	ld	(gintpoz),a		; osztott kperny sorszma
	ld	hl,gint			; HL= kiszolgl rutin cme
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa, folytats az utols kperny belltsval

;
;
;	Megszakts-kiszolgl az osztott grafikusmdhoz
;
gint:	di				; tovbbi megszak. tilt
	push	af			; hasznlt regiszterek mentse
	push	bc
	push	hl
	ld	hl,gr_div0		; HL a 0. osztott kperny adataira mutat
	ld	a,(gintpoz)		; A reg.= aktulis osztott kperny sorszma
	dec	a
	jr	z,gint0			; ugrs, ha az 1. kperny volt az aktv
	ld	a,001h
	ld	hl,gr_div1		; HL a 1. osztott kperny adataira mutat
gint0:	ld	(gintpoz),a		; osztott kperny sorszmnak mentse
	ld	a,(hl)
	inc	hl
	ld	c,060h			; C= 0. paletta-regiszter I/O cme (eddig 121 raciklus az elejtl -> kb. 40us)
	out	(006h),a		; +11 videmd belltsa (7.bit-nyomtat strobe  5..2bit- hang amplitd)
	outi				; +16  0. paletta regiszter blltsa
	inc	c			; +4
	outi				; +16  1. paletta regiszter blltsa
	inc	c			; +4
	outi				; +16  2. paletta regiszter blltsa
	inc	c			; +4
	outi				; +16  3. paletta regiszter blltsa  (sszesen 87 raciklus-> kb. 28us)
	ld	a,(hl)			; A reg.= osztott kperny befejez sora
	ld	l,a			; sorszm L-be is
	and	003h
	ld	bc,0A70h		; B= bels regiszter cme (R10)  C= CRTC cmregiszter I/O cme
	out	(c),b			; CRTC R10-es regiszter cmzse
	out	(071h),a		; regiszter belltsa
	inc	b
	out	(c),b			; CRTC R11-es regiszter cmzse
	out	(071h),a		; regiszter belltsa
	ld	a,l			; A reg.= osztott kperny befejez sora
	rlca				; (sor / 4) * 64 -> sor * 16
	rlca
	rlca
	rlca
	ld	l,a
	and	00Fh			; A reg.= karakterpozci fels bjtja
	ld	b,00Eh			; B= R14-es regiszter cme
	out	(c),b			; CRTC R14-es regiszter cmzse
	out	(071h),a		; regiszter belltsa
	inc	b
	ld	a,l
	and	0C0h			; A reg.= karakterpozci als bjtja
	add	a,001h			; soron elejn a megszakts, mert kb. 40us telik el a regiszterek belltsig
	out	(c),b			; CRTC R15-s regiszter cmzse
	out	(071h),a		; regiszter belltsa
	out	(007h),a		; kurzor/hang megszak. krs trlse
	pop	hl			; regiszterek vissza
	pop	bc
	pop	af
	ei				; megszak. eng
	ret				; visszatrs

;
;
;	Osztott grafikusmd kikapcsolsa
;
resgint:halt				; vrakozs a kvetkez megszaktsra
	ld	a,(gintpoz)		; A reg.= aktulis osztott kperny sorszma
	cp	001h
	jr	z,resint		; ugrs, ha az utols osztott kprny megjelentsnl tart
	halt				; egybknt mg vr egy megszaktst, majd a megszaktsrutin helyrelltsa
;
;
;	Eredeti megszakts visszalltsa
;
resint:	di				; megszak. tilt
	ld	hl,osint		; HL= eredeti megszak. rutin visszalltand kdrszlete
	ld	de,0038h		; DE= megszak. cme
	ld	bc,0003h		; BC= 3 bjt lesz
	ldir				; bjtok msolsa
	ld	a,(0B12h)		; A reg.= Port5 tkrkpe
	res	5,a			; hang IT tiltva
	res	4,a			; hangjel is tiltva
	ld	(0B12h),a		; j rtk a memriba
	out	(005h),a		; s a portra
	ld	a,00Ah			; CRTC R10-es regiszterben a kurzor engedlyezse
	out	(070h),a
	ld	a,003h
	out	(071h),a
	ei				; megszak. eng.
	call	dint_ena		; lemezvezrl megszak. tllts engedlyezse
	ret

;
;	Eredeti megszak. rutin visszalltand kdrszlete
;
osint:	push	af
	ld	a,070h


;
;
;	Hang megszakts engedlyezse, lejtszs alaphelyzetbe lltsa
;
setsnd:	call	dint_dis		; lemezvezrl megszak. tllts tiltsa
;
	di				; megszak. tilt	
	ld	hl,00010h		; lejtszs inicializlsa (fejlc 16 bjtjt tlpi)
	ld	(playadr),hl		; adatok kezdete
	ld	hl,00200h		; H = az aktulis adatbjtban htralv mintk szma
	ld	(sample),hl
	ld	hl,(rd_data)		; HL= a betlttt fjl elejnek kezdete a memriban
	ld	de,0005h		; DE= eltols a fejlcben lv pitch rtkhez
	add	hl,de
	ld	a,(hl)			; A reg.= lejtszsi sebessg pitch rtknek fels bjtja
	and	00Fh			; csak az als 4 bit megtartsa
	ld	e,a
	dec	hl
	ld	a,(hl)
	out	(004h),a		; PITCH als 8 bit belltsa
	ld	a,(0B12h)		; A= Port5 tkrkpe
	and	0C0h			; fels 2 bit megtartsa
	or	e			; j PITCH rtk az als 4 bitbe
	or	020h			; hang IT engedlyezse
	ld	(0B12h),a		; j rtk a memriba
	out	(005h),a		; s a portra
	ld	a,00Ah
	out	(070h),a		; CRTC bels regiszternek kivlasztsa (R10)
	ld	a,003h
	or	020h			; kurzor tiltsa
	out	(071h),a		; bels regiszter j rtknek bersa
;
	ld	hl,sndint		; HL= belltand megszak. kiszolgl kezd cme
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa
	ei				; megszak. eng.
	ret

;
;
;	Sajt megszakts-kiszolgl rutin hanglejtszshoz
;
sndint:	di				; tovbbi megszak. tilt
	push	af			; A reg. mentse
	ld	a,090h			; memrialapozs: U0,U1,VID,U3
	out	(002h),a		; memrialapozs belltsa
	out	(007h),a		; kurzor/hang megszak. krs trlse
	push	hl
	call	sndply			; hanglejtsz rutin hvsa
	pop	hl
	ld	a,(0003h)		; eredeti memrialapozs vissza
	out	(002h),a
	pop	af			; A reg. vissza
	ei				; megszak. eng
	ret				; visszatrs

;
;
;	Hang lejtszsa (4bit/minta)
;
sndply:	ld	hl,(sample)
	ld	a,l			; aktulis adatbjt A reg.-be
	dec	h
	jr	nz,sndpl0		; ugrs, ha mg az els mintt kell kiadni
	rlca				; a msodik minthoz ktszer balra kell lptetni az adatbjtot
	rlca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
mod1:	or	082h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	hl,(playadr)		; HL-ben az aktulisan jtszott mintabjt cme
	inc	hl			; cm nvelse
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	ld	(playadr),hl
	ld	l,(hl)			; L= a kvetkez 2 mintt tartalmaz bjt
	ld	h,002h			; H= 2 minta van a bjtban
	ld	(sample),hl		; minta jellemzi a sajt vltozba
	ret
;
sndpl0:	rrca				; az els minthoz ktszer jobbra kell lptetni az adatbjtot
	rrca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
mod2:	or	082h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	(sample),hl		; frisstett szmll vissza
	ret

;
;
;	Lemezvezrl megszakts tllts engedlyezse/tiltsa
;
dint_ena:
	ld	d,000h			; D= 000h -> engedlyezs
	jr	dint0
;
dint_dis:
	ld	d,0FFh			; D= 0FFh -> tilts
dint0:	ld	e,02Bh			; E= INT_ENA vltoz sorszma
	ld	b,0FFh			; B= 0FFh -> rs
	ld	hl,0000h
	ld	(fstr_FPB),hl		; FPB:IX - most nem hasznlt
	ld	(fstr_FPB+2),hl		; FPB:HL - most nem hasznlt
	ld	(fstr_FPB+4),de		; FPB:DE - D= j adat  E= vltoz sorszma
	ld	(fstr_FPB+6),bc		; FPB:BC - B=0 olvass, egybknt rs
	ld	de,fstr_FPB		; DE= FPB cme
	ld	c,01Ah			; C = FISH funkci: rendszervltoz beolvassa/rsa
	rst	30h
	.db	219			; FISH funkci hvsa MOPS-on keresztl
	ret

;
;
;	Brmely billenty lenyomsnak vizsglata
;	in: -
;	out: ZF - ZF=1 -> nem nyomtak gombot
;	     CY - CY=1 -> ESC-et nyomtak
;
chkey:	ld	e,0FFh			; E-ben lesz az sszestett eredmny
	ld	a,(0B11h)		; A reg.= Port3 tkrkpe (billentyzetsor)
	and	0F0h			; fels 4 bit meghagyva
	ld	c,a			; aktulis kivlaszt rtk C-be is
	ld	b,008h			; 8 sort vizsgl meg ciklusban
chkey0:	out	(003h),a		; sorcm kirsa a portra
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	ld	d,a			; sor msolata D-be is (az utols ciklusban az ESC sora lesz)
	and	e			; eredmny sszestse
	ld	e,a			; ments E-be
	inc	c			; sorcm nvelse
	ld	a,c
	djnz	chkey0
	out	(003h),a		; jobb oldali joy s INS billenty sora
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	and	e			; eredmny sszestse
	ld	e,a			; ments E-be
	inc	c			; sorcm nvelse
	ld	a,c
	out	(003h),a		; bal oldali joy
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	and	e			; eredmny sszestse, CY=0
	inc	a
	ret	z			; visszatrs, ha nem nyomtak gombot (ZF=1 CY=0)
	bit	3,d			; ESC billenty ellenrzse
	ret	nz			; visszatrs, ha nyomtak gombot, de nem ESC-et (ZF=0 CY=0)
	or	a			; ZF=0
	scf				; CY=1
	ret

;
;
;	ESC billenty llapotnak beolvassa
;	in: -
;	out:  C - lenyomott billenty ASCII kdja (ESC) vagy 0
;	     ZF - ZF=1 valamelyik vizsgland billentyt lenyomtk
;
chesc:	ld	a,(0B11h)		; A reg.= Port3 tkrkpe (billentyzetsor)
	and	0F0h			; fels 4 bit meghagyva
	or	007h			; a 7. sor kivlasztsa	
	ld	(0B11h),a		; j rtk a memriba
	out	(003h),a		; s a portra
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	bit	3,a			; ESC billenty ellenrzse
	ld	c,01Bh			; C= ESC karakterkdja
	ret	z			; visszatrs, ha ESC-et nyomtak
	ld	c,000h			; egybknt C=0 -val tr vissza, ZF=0
	ret

;
;	Progresszbr sornak trlse a kpernyn
;	in:  -
;	out: -
;
clrpbar:ld	hl,08000h + (239 * 64)	; HL= legals sor kezdete a vidememriban
	ld	(progres),hl		; itt kell majd kezdeni az invertlst is
	ld	(hl),000h
	ld	d,h
	ld	e,l
	inc	de
	ld	bc,63			; legals sor trlse, itt lesz a progresszbr
	ldir
	ret

;
;
;	Hangfjl lejtszsa
;	in: -
;	out: CY - CY=1 -> ESC-et nyomtak vagy lemezes hiba trtnt
;
lejatsz:ld	de,rw4path		; hangfjl megnyitsa
	rst	30h
	.db	211			; CAS_OPEN
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
	ld	bc,0000h		; eltols= 0000:0000h
	ld	de,0000h
	rst	30h
	.db	216			; fjlmutat belltsa a fjl vghez kpest
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
	ld	l,e			; HL= fjlmret 8kB-os maradka
	ld	a,d
	and	01Fh
	ld	h,a
	ld	(lsblokk),hl		; utols blokkban lv bjtok szmnak mentse
	sla	d			; fjlmret osztsa 8kB-al (2000h)
	rl	c
	rl	b
	sla	d
	rl	c
	rl	b
	sla	d
	rl	c
	rl	b			; eredmny BC-ben
	ld	a,b			; ellenrzs
	or	c
	jp	z,beolv4		; ugrs, ha 0 az eredmny (hibt nem jelez)
	ld	(nblokk),bc		; blokkokszm mentse a ksbbiekre
	ld	bc,0000h		; eltols= 0000:0000h
	ld	de,0000h
	rst	30h
	.db	214			; fjlmutat belltsa a fjl elejhez kpest
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
	ld	hl,04000h		; els blokk beolvassa U1 RAM elejre
	ld	(rd_data),hl
	ex	de,hl			; DE= tltsi cm
	ld	bc,02000h		; BC= beolvasand bjtok (8192)
	ld	(blen),bc		; lejtszand hossz belltsa
	rst	30h
	.db	210			; CAS_BKIN
	or	a
	jp	nz,beolv4		; ugrs, ha hiba volt
;
	call	clrpbar			; progresszbr sornak letrlse
	call	setsnd			; lejtszs alaphelyzetbe lltsa, hang megszakts engedlyezse
;
	ld	hl,06000h		; kvetkez blokk beolvassa majd U1 RAM kzepre (folytats cirkulrisan)
	ld	(rd_data),hl
	ld	hl,(nblokk)		; HL= 8kB-os blokkok szma
	ld	b,l			; B= htralv beolvasand blokkok szma (most csak max. 255 -> 2MB)
	xor	a			; hibakd trlse
	dec	b			; cskkents 1-el (az elst mr beolvasta)
	jr	z,beolv4		; ugrs, ha 0 lenne a blokkszm
	ld	c,002h			; C a kls ciklus-szmll
	ld	hl,02000h		; HL= beolvasand bjtok (8192)
beolv0:	push	bc
	ld	b,h			; beolvasand bjszm BC-be
	ld	c,l
	ld	(blen),hl		; lejtszand hossz belltsa
	ld	de,(rd_data)		; DE= tltsi cm
	rst	30h
	.db	210			; CAS_BKIN
	or	a
	jr	nz,beolv3		; ugrs, ha hiba volt
;
	xor	a			; A reg.= szmll az invertland bjt lptetshez
	ld	bc,(progres)		; aktulisan invertland kpbjt cme
	ld	de,(rd_data)		; DE= legutbbi tltsi cm
beolv1:	halt				; vrakozs a megszaktsra
	inc	a
	bit	6,a
	jr	z,beolv2		; ugrs, ha A reg. mg nem 64
	ld	a,(bc)			; kpbjt beolvassa
	cpl
	ld	(bc),a			; invertlt kpbjt visszarsa
	inc	c
	set	6,c			; fels kt bit 1-be -> mindig csak az utols sort mdostja
	set	7,c
	xor	a
beolv2:	ld	hl,(playadr)
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	or	a
	sbc	hl,de			; cmek sszehasonltsa
	jr	nz,beolv1		; vrakozs, amg a lejtszs nem tart a legutbb beolvasott adatoknl
	ld	(progres),bc
	ld	a,020h			; tltsi cm nvelse 8192-vel
	add	a,d
	and	03Fh			; cm fels kt bitje 01b -> U1 RAM cmzse
	or	040h
	ld	d,a
	ld	(rd_data),de		; j tltsi cm mentse
	call	chesc			; billentyzet vizsglata
	ld	a,c			; lenyomott gomb ASCII kdja A reg.-be
	pop	bc
	cp	01Bh
	jr	z,beolv4		; ugrs, ha ESC-et nyomtak (ilyenkor A reg.= 01Bh)
	ld	hl,02000h		; HL= beolvasand bjtok (8192)
	djnz	beolv0
	ld	hl,(lsblokk)		; HL= utols blokkban lv bjtok szma
	inc	b			; B = 1
	dec	c
	jr	nz,beolv0		; ugrs az utols lejtszsi ciklus kezdetre a maradk bjtokkal
	push	bc
	xor	a			; hibakd trlse
beolv3:	pop	bc
beolv4:	push	af
	call	resint			; megszaktsok helyrelltsa
	rst	30h
	.db	212			; CAS_CLOSE
	call	clrpbar			; progresszbr sornak letrlse
	pop	af
	or	a			; CY=0
	ret	z			; visszatrs, ha nem volt hiba
	cp	01Bh
	call	nz,hibair		; hiba kirsa, ha nem ESC volt
	scf				; CY=1
	ret

;
;
;	Kp beolvassa s megjelentse
;	in:  -
;	out: -
;
kepolv:	ld	de,keppath
	rst	30h
	.db	211			; CAS_OPEN
	or	a
	jr	nz,kepolv3
	ld	bc,0000			; eltols=0000 0000h
	ld	de,0000
	rst	30h
	.db	216			; fjlmutat belltsa a fjl vghez kpest
	or	a
	jr	nz,kepolv3
	or	b
	or	c
	jr	nz,kepolv1
	ld	hl,20000
	sbc	hl,de			; DE >20000 ?
	jr	nc,kepolv2
kepolv1:ld	de,20000		; max. 20000 bjt olvassa
kepolv2:ex	de,hl
	ld	bc,0000			; eltols=0000 0000h
	ld	de,0000
	rst	30h
	.db	214			; fjlmutat belltsa a fjl elejhez kpest
	or	a
	jr	nz,kepolv3
	ld	b,h			; BC= beolvasand bjtok
	ld	c,l
	ld	de,puffer		; DE= tltsi cm
	rst	30h
	.db	210			; CAS_BKIN
kepolv3:push	af
	rst	30h
	.db	212			; CAS_CLOSE
	pop	af
	or	a
	jp	nz,hibair
	ld	hl,puffer
	call	kirajz
	ld	a,(puffer + 3)		; kp tpusa
	and	KEPTYPE_COLMASK
	or	080h
	ld	(mod1+1),a		; a hanglejtsz rutinban Port6 fix bitjeinek belltsa
	ld	(mod2+1),a
	ret

;
;
;	Lejtszs utn az ismtls megkrdezse
;	in: -
;	out: CY - CY=1 -> ESC-et nyomtak
;
ismet:	ld	c,KEPTYPE_4COL		; 4-szn kp lesz
	ld	de,08000h		; a kperny elejre rajzolja ki
	ld	hl,kerkep+KEPHEAD_XSIZE	; HL a kpadatokra mutat
	call	kepre2			; tmrtett kp kirajzolsa
	call	setgint			; osztott grafikusmd belltsa
ism0:	call	chkey			; vrakozs egy billenty lenyomsra
	jr	z,ism0
	push	af			; CY mentse
	ld	hl,08000h		; az els 16 kpernysor trlse
	ld	(hl),000h
	ld	d,h
	ld	e,l
	inc	de
	ld	bc,(16*64)-1
	ldir
	call	resgint			; osztott grafikusmd kikapcsolsa
	pop	af			; CY vissza
	ret


;
;	Hibakd kirsa
;	in:  A - hibakd
;	out: -
;
hibair: ld	h,a			; hibakd H-ba
	ld	bc,9
	ld	de,hszov
	rst	30h
	.db	34			; ED_BKOUT blokk krsa kpernyre
	ld	a,h			; hibakd vissza A reg.-be
	call	knv
	ld	c,'H'			; 'H' bet kirsa a szm utn
	rst	30h
	.db	33
	rst	30h			; vrakozs billenty lenyomsra
	.db	145			; KBD_CHIN
	ret

;
;	8-bites hexa szm kirsa
;	in:  A - kirand bjt
;	out: A - megrzdik
;	     H - szintn a kirt bjtot tartalmazza
;
knv:	ld	l,002h			; L= 2 hexa szmjegy lesz kirva
	ld	h,a			; kirand rtk H-ba is
	rrca
	rrca
	rrca
	rrca
knv0:	and	00Fh			; als hexa szmjegy maszkolsa
	add	a,030h			; konvertls ASCII-ba
	cp	03Ah
	jr	c,knv1
	add	a,007h
knv1:	ld	c,a
	rst	30h
	.db	021h			; ED_CHOUT
	ld	a,h
	dec	l
	jr	nz,knv0			; ismtls amg ki nem rta mindkt szmjegyet
	ret

;
hszov	.db	"Hiba: A= "
;
rw4path	.db	008h,"demo.rw4"
keppath	.db	008h,"demo.kep"
;
#include "keplib.asm"
;
kerkep	.equ	$
;
puffer	.equ	kerkep + 603
;
.end
