;
;	Fjlkezel segdprogram
; //csak VT-DOS1.2 vagy magasabb verzival//
;

PATH	.db	0,0			; az utvonalnv mutatja
FILE	.db	0,0			; a fjlnv mutatja (8+3)
FULLPTH	.db	0,0			; a teljes tvonalnv mutatja
fn_all	.db	"???????????"		; fjlnv minden fjlhoz (*.*)
dirtxt	.db	"   <dir>   "		; alknyvtr nevnek kirshoz
meghtxt .db	"A:         "		; meghajtk listzshoz
	.db	10h			; attributum: alknyvtr
	.dw	(23 * 2048) + (00 * 32) +00	; id:   23h-00m-00s
	.dw	(27 * 512) + (12 * 32) + 5	; dtum: 2007-12-05
	.db	0,0,0,0			; fjlhossz: 0
akt_bj	.db	0,0			; a tallt fjlnevek aktulis pointere
xaktbj	.db	0
nbj	.db	0			; a tallt fjlnevek szma
nbj_max	.equ	50			; fjlnevek maximlis szma
bcdMSB	.db	0,0,0,0
bcdLSB	.db	0			; BCD alak szm trolshoz a BIN->ASCII konverzinl
akt_ln	.db	0			; az aktulisan kijellt sor szma
fst_ln	.equ	3			; az els bejegyzst tartalmaz sor a kpernyn
lst_ln	.equ	24			; az utols sor

;
;	Fjlnv beolvassa megnyitshoz
;	in:  HL=utvonalnv stringre mutat
;	     DE=fjlnv stringre mutat
;	     BC=a kimeneti teljes tvonal string cme
;
fk_open:ld	(PATH),hl
	ld	(FILE),de
	ld	(FULLPTH),bc
fk_op0:	ld	c,0		; GRAPHICS 2, kperny trlse
	rst	48
	.db	4
	di
	ld	a,50h		; 50h = U0, U1, VID, SYS
	out	(2),a		; memrialapozs belltsa
	ld	(3),a
	ei
	ld	bc,0101h	; pozici X=1 Y=1
	ld	hl,(PATH)
	call	fk_prnt		; tvonal kirsa
	call	fk_dir		; az adott knyvtr tartalmnak beolvassa
	call	nz,fk_err	; hiba kezelse
	call	fk_dspl		; knyvtrtartalom megjelentse
	ld	a,fst_ln	; az els sor inverz megjelentse
	ld	(akt_ln),a
	call	fk_linv
	ld	hl,nevtbl
	ld	(akt_bj),hl
	ld	a,0
	ld	(xaktbj),a
fk_op1:	rst	48		; vrakozs egy gomb lenyomsra
	.db	145		; KBD_CHIN
	ld	a,c
	cp	224		; bal oldali joystick rtkeinek konvertlsa
	jr	c,fk_op2
	sub	224
fk_op2:	cp	24		; JOY le
	jr	nz,fk_op4
	ld	a,(nbj)		; bejegyzsek szma
	ld	b,a
	ld	a,(xaktbj)
	inc	a
	cp	b
	jr	z,fk_op1	; ugrs, ha ez volt az utols tallt bejegyzs
	ld	(xaktbj),a
	ld	hl,(akt_bj)	; kvetkez bejegyzs cmre ll
	ld	de,20		; egy bejegyzs hossza
	add	hl,de
	ld	(akt_bj),hl
	ld	a,(akt_ln)
	call	fk_linv		; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	inc	a
	ld	(akt_ln),a
	cp	lst_ln+1	; utols utni sor?
	jr	nz,fk_op3
	dec	a
	ld	(akt_ln),a	; ha igen, helybenmarad
	call	fk_scup		; s scroll felfel
	ld	bc,1*256+lst_ln	; X=1  Y=utols sor
fk_op3a:rst	48		; sugrpozicionls az aktulis bejegyzs kirshoz
	.db	35		; CPOS
	ld	hl,(akt_bj)
	call	fk_fnev		; szveg elksztse
	ld	de,formpuff
	rst	48		; szveg kirsa: formzott fjlnv
	.db	34		; ED_BKOUT
fk_op3:	ld	a,(akt_ln)
	call	fk_linv
	jp	fk_op1
fk_op4:	cp	5		; JOY fel
	jr	nz,fk_op6
	ld	a,(xaktbj)
	dec	a
	cp	0FFh
	jr	z,fk_op1	; ugrs, ha ez volt a legels bejegyzs
	ld	(xaktbj),a
	ld	hl,(akt_bj)	; kvetkez bejegyzs cmre ll
	ld	de,20		; egy bejegyzs hossza
	or	a
	sbc	hl,de
	ld	(akt_bj),hl
	ld	a,(akt_ln)
	call	fk_linv		; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	dec	a
	ld	(akt_ln),a
	cp	fst_ln-1	; els eltti sor?
	jr	nz,fk_op3
	inc	a
	ld	(akt_ln),a	; ha igen, helybenmarad
	call	fk_scdw		; s scroll lefel
	ld	bc,1*256+fst_ln	; X=1  Y=els sor
	jp	fk_op3a
fk_op6:	cp	13		; RETURN
	jr	z,fk_op7
	cp	32		; SPACE
	jr	z,fk_op7
	cp	6		; JOY tz
	jr	nz,fk_op8
fk_op7:	call	fk_slct
	jp	nz,fk_op1
	ld	c,0		; GRAPHICS 2, kperny trlse
	rst	48
	.db	4
	ld	a,1		; A=0x01 ->kivlaszts trtnt
	ret
fk_op8:	cp	27		; ESC
	jp	nz,fk_op1
	ld	c,0		; GRAPHICS 2, kperny trlse
	rst	48
	.db	4
	ld	a,0FFh		; A=0xFF ->CANCEL	
	ret
;
;	Hibakezels
;
fk_err:	cp	0A1h		; "file not found"- utols tallat utn
	jr	nz,fk_er1
	ld	a,(nbj)
	or	a
	ret	nz		; nincs hiba, ha tallt legalbb 1 fjlt
	ld	a,0A1h
	jp	fk_er3
fk_er1:	cp	0A0h		; "dir not found"- lemezcsere trtnhetett
	jr	nz,fk_er2
	ld	hl,(PATH)
	ld	(hl),0		; tvonalnv nullzsa
	pop	bc
	jp	fk_op0		; jra prblkozik
fk_er2:	cp	0ADh		; "disk operation aborted"- nincs lemez, vagy rossz
	jr	nz,fk_er3
	ld	hl,(PATH)
	ld	(hl),0		; tvonalnv nullzsa
	pop	bc
	jp	fk_op0		; jra prblkozik
fk_er3:	call	hibair		; kirja A reg.-ben adott hibt
	ld	c,0		; GRAPHICS 2, kperny trlse
	rst	48
	.db	4
	ld	a,0FFh		; A=0xFF ->CANCEL
	pop	bc		; hiba utni visszatrsi cm eltvoltsa	
	ret
;
;	Szveg msolsa a specilis karakterig
;	in:  B=maximlis hossz  C=specilis karakter
;	     DE=cl  HL=specilis karakterrel lezrt forrs
;	out: DE=utols karakter utn mutat
;	     HL=a specilis karakterre mutat
;
fk_scpy:ld	a,(hl)
	cp	c
	ret	z
	ld	(de),a
	inc	de
	inc	hl
	djnz	fk_scpy
	ret
;
;	Teljes utvonalnv ksztse az aktulis fjl nevbl s az tvonalbl
;
fk_fpth:ld	de,(FILE)	; fjlnv elksztse
	ld	hl,(akt_bj)	; aktulis bejegyzs cme
	ld	bc,0820h	; max_hossz=8 spec.kar=32
	call	fk_scpy		; fjlnv msolsa
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	hl,(akt_bj)
	ld	bc,0008
	add	hl,bc
	ld	bc,0320h	; max_hossz=3 spec.kar=32
	call	fk_scpy		; kiterjeszts msolsa
	xor	a
	ld	(de),a
	ld	de,(FULLPTH)
	inc	de		; a 0. bjt a hossz lesz
	ld	hl,(PATH)
	ld	bc,0000h	; max_hossz=256 spec.kar=0
	call	fk_scpy		; tvonal msolsa
	ld	a,92		; '\'
	ld	(de),a
	inc	de
	ld	hl,(FILE)
	ld	bc,0000h	; max_hossz=256 spec.kar=0
	call	fk_scpy		; fjlnv msolsa
	ld	hl,(FULLPTH)
	inc	hl
	ex	de,hl
	or	a
	sbc	hl,de		; gond, ha 255 karakternl hosszabb az tvonal
	ld	a,l
	dec	de
	ld	(de),a		; hossz belltsa
	xor	a
	ret
;
;	Kvetkez fjlnv kiolvassa a knyvtr-listbl
;
;	in:  HL,DE,BC - az egyes rszstringek cmei
;	out: A=0 -sikeres tallat   A=2 -nincs tallat
;
fk_nxfn:ld	(PATH),hl
	ld	(FILE),de
	ld	(FULLPTH),bc
	ld	c,0
fk_nx0:	ld	hl,(akt_bj)	; kvetkez bejegyzs cmre ll
	ld	de,20		; egy bejegyzs hossza
	add	hl,de
	ld	a,(nbj)		; bejegyzsek szma
	ld	b,a
	ld	a,(xaktbj)
	inc	a
	cp	b
	jr	nz,fk_nx1	; ugrs, ha nem ez az utols tallt bejegyzs
	inc	c
	ld	a,2
	cp	c
	ret	z		; a vgtelen ciklus elkerlse vgett
	ld	a,0
	ld	hl,nevtbl
fk_nx1:	ld	(xaktbj),a
	ld	(akt_bj),hl
	ld	de,11
	add	hl,de
	ld	a,(hl)
	and	10h		; attributum ellenrzse
	jp	z,fk_fpth	; ha fjl, visszatr az elksztett tvonalnvvel
	jp	fk_nx0
;
;	Elz fjlnv kiolvassa a knyvtr-listbl
;
;	in:  HL,DE,BC - az egyes rszstringek cmei
;	out: A=0 -sikeres tallat   A=2 -nincs tallat
;
fk_prfn:ld	(PATH),hl
	ld	(FILE),de
	ld	(FULLPTH),bc
	ld	c,0
fk_pr0:	ld	hl,(akt_bj)	; az elz bejegyzs cmre ll
	ld	de,20		; egy bejegyzs hossza
	or	a
	sbc	hl,de
	ld	a,(xaktbj)
	dec	a
	cp	0FFh
	jr	nz,fk_pr1	; ugrs, ha nem ez az els tallt bejegyzs
	inc	c
	ld	a,2
	cp	c
	ret	z		; a vgtelen ciklus elkerlse vgett
	ld	a,(nbj)
	dec	a
	call	fk_drad
fk_pr1:	ld	(xaktbj),a
	ld	(akt_bj),hl
	ld	de,11
	add	hl,de
	ld	a,(hl)
	and	10h		; attributum ellenrzse
	jp	z,fk_fpth	; ha fjl, visszatr az elksztett tvonalnvvel
	jp	fk_pr0
;
;	Knyvtr-bejegyzs cmnek szmtsa
;
;	in:  A=sorszm
;	out: HL=memria cm  A=bemeneti sorszm
;
fk_drad:ld	hl,0000		; HL-ben lesz a szorzs eredmnye
	ld	de,20		; egy bejegyzs hossza 20 bjt
	ld	b,8		; 8-bites szorzs lesz
drad0:	add	hl,hl		; HL egy bittel balra lptetse
	rlca			; aktulis bit CY-be
	jr	nc,drad1	; ha CY=0 csak 2-vel kellett szorozni HL-t
	add	hl,de		; egybknt DE-t is hozz kell adni
drad1:	djnz	drad0
	ld	de,nevtbl	; tallt 20 bjtos nvbejegyzsek kezdete
	add	hl,de
	ret
;
;	RETURN/SPACE/JOY tz ellenrzse
;
fk_slct:ld	hl,(akt_bj)	; aktulis bejegyzs cme
	ld	de,11
	add	hl,de
	ld	a,(hl)
	and	10h		; attributum ellenrzse
	jr	nz,slct0d	; ugrs, ha nem fjl van kivlasztva
	call	fk_fpth
	ret
slct0d:	ld	hl,(PATH)
	xor	a
	cp	(hl)
	jr	nz,slct0
	ex	de,hl		; ha az els karakter 0 volt, akkor meghajt root-t llt be
	ld	hl,(akt_bj)
	ldi			; meghajt betjele
	ldi			; kettspont
	ex	de,hl
	ld	a,92		; '\'
	ld	(hl),a
	inc	hl
	jp	slct3
slct0:	ld	a,(hl)		; tvonal-string vgnek megkeresse
	inc	hl
	or	a
	jr	nz,slct0
	dec	hl
	dec	hl		; vgcm cskkentse ha a meghajt gykerben van
	ld	a,92		; '\'
	cp	(hl)
	jr	z,slct0e
	inc	hl
slct0e:	ex	de,hl		; DE=a lezr nulla cme a PATH-ban
	ld	hl,(akt_bj)	; most a kivlasztott alknyvtrnv elemzse jn
	ld	a,(hl)
	cp	'.'		; visszalps egy knyvtrral?
	jr	nz,slct1	; ugrs ha nem
	inc	hl
	ld	a,(hl)
	cp	' '		; ez az aktulis knyvtr jelzse volt?
	jr	nz,slct0c
	or	a		; A=32, ZF=0  (NZ)
	ret
slct0c:	cp	'.'
	dec	hl
	jr	nz,slct1
	ld	hl,(PATH)	; visszalps egy knyvtrral
	dec	hl
	ex	de,hl		; DE=tvonal puffer kezdcme-1
	dec	hl
slct0a:	ld	a,(hl)
	or	a		; CY=0
	sbc	hl,de		; lltja ZF-t
	add	hl,de		; ez nem lltja ZF-t
	jr	z,slct0b	; tllpte a puffer kezdett?
	dec	hl
	cp	92		; '\'
	jr	nz,slct0a
	ld	a,(hl)
	cp	':'		; meghajt gykrknyvtra?
	jr	nz,slct0b
	inc	hl		; ha igen, meghagyja a visszapert
slct0b:	inc	hl
	jr	slct3
slct1:	ex	de,hl
	ld	a,92		; '\'
	ld	(hl),a
	inc	hl
	ld	b,8		; csak 8 karaktert msol az alknyvtr nevbl
slct2:	ld	a,(de)
	cp	33		; 0..32 karakterek fjlnv vget jellhetnek
	jr	c,slct3
	ld	(hl),a
	inc	hl
	inc	de
	djnz	slct2
slct3:	xor	a
	ld	(hl),a		; lezr nulla
	pop	hl		; a CALL utasts visszatrsi cmnek eltvoltsa
	jp	fk_op0		; tmeneti megoldsknt
;
;	Tallt knyvtr-bejegyzsek kirsa
;
fk_dspl:ld	b,lst_ln-fst_ln+1	; maximlisan kirhat sorok szma
	ld	a,(nbj)
	cp	b		; a tallt bejegyzsek szma ennl kevesebb?
	jr	nc,dspl0
	or	a
	ret	z		; vge, ha egy bejegyzs sincs
	ld	b,a
dspl0:	ld	c,fst_ln	; az els sor szma
	ld	de,nevtbl
dspl1:	push	bc
	push	de
	ld	b,01		; X=1  Y=akt. sor
	rst	48		; sugrpozicionls
	.db	35		; CPOS - az editoron keresztl gyorsabb a kirats
	pop	hl
	push	hl
	call	fk_fnev
	ld	de,formpuff
	rst	48		; szveg kirsa: formzott fjlnv
	.db	34		; ED_BKOUT
	pop	de
	ld	hl,20
	add	hl,de		; kvetkez nvre ll
	ex	de,hl
	pop	bc
	inc	c		; kvetkez sor
	djnz	dspl1		; ismtls az sszes sor vgig
	ret
;
;	Szveg kirsa adott karakteres pozciba
;	in:  B=X poz.  C=Y poz.  HL=0-val lezrt string
;
fk_prnt:rst	48		; kurzor-pozicionls
	.db	35		; CPOS
fk_prn0:ld	d,h
	ld	e,l
	ld	bc,0FFFFh
fk_prn1:inc	bc		; karakterek megszmolsa
	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,fk_prn1
	ld	a,b
	or	c
	ret	z
	rst	48		; szveg kirsa
	.db	34		; ED_BKOUT
	ret
;
;	Egy szveges sor inverz megjelentse
;
;	in: A=sor szma (1..24)
;
fk_linv:dec	a		; sorszm 0..23 kz igaztva
	ld	hl,0000		; HL-ben lesz a szorzs eredmnye
	ld	de,640		; egy sor hossza 64*10 bjt
	rla			; a fels 3 bit nem rdekes
	rla
	rla
	ld	b,5		; 5-bites szorzs lesz
linv0:	add	hl,hl		; HL egy bittel balra lptetse
	rla			; aktulis bit CY-be
	jr	nc,linv1	; ha CY=0 csak 2-vel kellett szorozni HL-t
	add	hl,de		; egybknt DE-t is hozz kell adni
linv1:	djnz	linv0
	ld	de,8000h	; video-memria kezdete a 2. lapon
	add	hl,de		; HL=sor els bjt cme a memriban
	ld	c,10		; egy szveges sor 10 kppont magas
linv2:	ld	b,64		; s 64 bjtos
linv3:	ld	a,(hl)
	cpl			; 2-szn mdban egyszeren csak invertlni kell
	ld	(hl),a		; a kpbjtot
	inc	hl
	djnz	linv3
	dec	c
	jr	nz,linv2
	ret
;
;	Kperny scroll-ozsa
;
fk_scup:ld	hl,fst_ln*640+8000h
	ld	de,(fst_ln-1)*640+8000h
	ld	bc,(lst_ln-fst_ln)*640
	ldir
	ret
;
fk_scdw:ld	hl,(lst_ln-1)*640-1+8000h
	ld	de,lst_ln*640-1+8000h
	ld	bc,(lst_ln-fst_ln)*640
	lddr
	ret
;
;	Meghajt azonostk listzsa
;
fk_root:
	ld	bc,20		; 8+3 fjlnv + attributum + id +hossz
	ld	de,nevtbl	; tallt 20 bjtos nvbejegyzsek kezdete
	ld	hl,meghtxt	; A meghajt
	ldir
	ld	a,'B'		; B meghajt
	ld	(de),a
	inc	de
	ld	bc,19		; 8+3 fjlnv + attributum + id +hossz
	ld	hl,meghtxt+1
	ldir
	ld	(akt_bj),de	; nvmutat mentse, mr a kv. bejegyzsre mutat
	ld	a,02		; tallt fjlok szma
	ld	(nbj),a
	xor	a		; ZF=1 - nincs hiba
	ret
;	
;	Egy knyvtr fjlneveinek beolvassa
;
fk_dir:
	ld	hl,(PATH)
	xor	a
	cp	(hl)
	jp	z,fk_root		; ha nincs tvonal megadva, akkor a meghajtk listzsa
;
	inc	hl
	inc	hl
	inc	hl
	cp	(hl)			; ha pl. "A:\0" az tvonalnv
	ld	hl,nevtbl		; tallt 20 bjtos nvbejegyzsek kezdete
	jr	nz,fk_d0		; ugrs, ha nincs lezr nulla
	ld	a,'.'			; egy "elz knyvtr" bejegyzs ltrehozsa
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	de,meghtxt+2
	ld	bc,18
	ex	de,hl
	ldir
	ex	de,hl			; HL=kvetkez bejegyzs cme
	ld	a,01			; egy bejegyzs mr van
fk_d0:	ld	(akt_bj),hl
	ld	(nbj),a			; tallati szmll kezd rtke
;
	ld	hl,FCB_1
	ld	d,h			; hasznlatlan FCB kitltse
	ld	e,l
	xor	a
	ld	b,48			; 48 bjt trlse
fk_d1:	ld	(de),a
	inc	de
	djnz	fk_d1
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	ld	de,0006
	add	hl,de
	ld	(hl),0			; keressi attributum (nem keres ktet azonostt)
	inc	hl
	ld	(hl),0			; 0=aktulis meghajt
	inc	hl
	ld	de,fn_all
	ex	de,hl
	ld	bc,11			; 8+3 bjtos fjlnv tmsolsa
	ldir				; a tbbi vltoz nulla
;
	ld	hl,0000
	ld	(FPB),hl
	ld	hl,(PATH)		; FPB:IX most nem hasznlt
	ld	(FPB+2),hl		; FPB:HL=tvonalnv kezdete
	ld	hl,FPB+4
	ld	(hl),FCB_1 & 00FFh	; FPB:DE=hasznlatlan(amit keres) FCB
	inc	hl
	ld	(hl),FCB_1 / 256
	inc	hl
	ld	(hl),FCB_0 & 00FFh	; FPB:BC=hely a tallt FCB-nek
	inc	hl
	ld	(hl),FCB_0 / 256
	ld	de,FPB			; DE=FPB cme
	ld	c,04h			; C=FISH funkci: els keresse
	rst	48
	.db	219			; FISH funkci hvsa MOPS-on keresztl
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
;
fk_d2:	ld	de,FPB			; DE=FPB cme (FPB-ben BC s DE tartalma nem vltozik)
	ld	c,05h			; C=FISH funkci: kvetkez keresse
	rst	48
	.db	219			; FISH funkci hvsa MOPS-on keresztl
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli, de valsznleg nincs tbb fjl
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
	jr	nz,fk_d2		; ismtls az sszes bejegyzs megkeressig
	ret				; vagy amg el nem ri a maximlis fjlnv szmot
;
;
;	Egy 20 bjtos nvbejegyzs elksztse az adott FCB alapjn
;
;	in:  HL=FCB cme
;	out: DE->0..10   fjlnv (8+3)
;		 11      attributum
;		 12,13   mdosts ideje
;		 14,15   mdosts dtuma
;		 16..19  fjl hossza bjtban
;
fk_mnev:ld	a,0FEh
	cp	(hl)
	ret	nz		; vissza, ha nem meghatrozott FCB
	ld	bc,8
	add	hl,bc		; HL a fjlnvre mutat az FCB-n bell
	ld	a,(hl)
	cp	'.'
	jr	nz,mnev0
	inc	hl
	ld	a,(hl)
	dec	hl
	cp	' '		; ez az aktulis knyvtr jelzse lehet?
	jr	nz,mnev0
	ld	d,h
	ld	e,l
	ld	bc,11
	add	hl,bc		; az attributumot is ellenrizni kell
	ld	a,(hl)
	and	10h
	ret	nz		; visszatr, ha tnyleg az
	ex	de,hl
mnev0:	ld	de,(akt_bj)	; ide menti a nevet
	ld	bc,12		; 8+3 fjlnv + attributum
	ldir
	ld	bc,10
	add	hl,bc		; HL az id-adatokra mutat
	ld	bc,4		; 2 bjtos id + 2 bjtos dtum
	ldir
	inc	hl
	inc	hl
	ld	bc,4		; 4 bjtos fjlhossz
	ldir
	ld	(akt_bj),de	; nvmutat mentse, mr a kv. bejegyzsre mutat
	ld	a,(nbj)
	inc	a		; tallt fjlok szmnak nvelse
	ld	(nbj),a
	cp	nbj_max		; ha ZF=1, elrte a max. trolhat bejegyzst
	ret
;
;	Egy fjlnv kirsi furmtumnak elksztse
;
;	in:  HL=nv 20 bjtos bejegyzsnek kezdete
;	out: BC=formzott hossz
;
fk_fnev:ld	de,formpuff
	ld	bc,8		; fjlnv msolsa
	ldir
	ld	a,32
	ld	(de),a
	inc	de
	ld	bc,3		; kiterjeszts msolsa
	ldir
	push	hl		; az attributum cmnek mentse
	ld	(de),a
	inc	de
	ld	a,(hl)		; attributum elemzse
	and	10h		; alknyvtr ?
	jr	z,fnev0
	ld	hl,dirtxt
	ld	bc,11
	ldir
	jr	fnev1	
fnev0:	ld	bc,8
	add	hl,bc		; HL a fjlhosszra mutat
	call	fk_ascc		; fjlhossz kirsa
	ld	a,32
	ld	(de),a
	inc	de
fnev1:	pop	hl
	push	hl
	ld	bc,4
	add	hl,bc		; HL a dtum bjtokra mutat
	call	fk_date
	ld	a,32
	ld	(de),a
	inc	de
	pop	hl
	inc	hl
	inc	hl		; HL a id bjtokra mutat
	call	fk_time
	ld	bc,12+1+10+1+10+1+5	; szveg hossza
	ret			; egyenlre ennyi
;
;	BIN->BCD->ASCII konvertls
;
;	in: HL=binris szm fels bjtjnak cme
;	    DE=ASCII szm els karakternek cme
;
fk_ascc:push	de		; ASCII szm puffer-cmnek mentse
	xor	a
	ld	de,bcdMSB
	ld	b,5		; B=BCD szm hossza bjtban (5=>10 szmjegy)
ascc0:	ld	(de),a		; BCD szm nullzsa
	inc	de
	djnz	ascc0
	ld	b,04		; binris szm hossza bjtban
	ld	c,08		; 8-szor lpteti balra HL ltal mutatott bjtot
ascc1:	push	bc
ascc2:	ld	de,bcdLSB	; DE=BCD szm als bjtja
	ld	b,5		; B=BCD szm hossza bjtban
	rlc	(hl)
ascc3:	ld	a,(de)
	adc	a,a
	daa
	ld	(de),a
	dec	de
	djnz	ascc3
	dec	c
	jr	nz,ascc2
	dec	hl
	pop	bc
	djnz	ascc1
	ld	de,bcdMSB	; BCD konvertlsa ASCII-ba, DE=BCD fels bjtja
	pop	hl		; HL=ASCII szm els karaktere
	ld	b,5		; B=BCD szm hossza bjtban
ascc4:	ld	a,(de)		; a kezd 0-k helyettestse SPACE-el
	and	0F0h
	jr	nz,ascc5
	ld	(hl),20h	; SPACE bersa
	inc	hl
	ld	a,(de)
	and	0Fh
	jr	nz,ascc6
	ld	(hl),20h	; SPACE bersa
	inc	hl
	inc	de
	djnz	ascc4
	dec	hl
	ld	(hl),30h	; ha a szm=0, akkor az utols bjtra '0' kerl
	inc	hl
	ex	de,hl
	ret
ascc5:	ld	a,(de)		; hasznos szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
ascc6:	ld	a,(de)
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
	inc	de
	djnz	ascc5
	ex	de,hl
	ret
;
;	Egybjtos BIN szm konvertlsa 2-szmjegy DEC ASCII-ba
;
;	in: A=binris szm  DE=hova
;
fk_bcon:ld	c,a		; C-bl lpnek ki a bitek
	xor	a		; A-ban lesz a kt helyirtk BCD szm
	ld	b,08		; 8-szor lpteti balra
bcon0:	rlc	c
	adc	a,a
	daa
	djnz	bcon0
bcon1:	ld	b,a		; BCD szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ld	a,b
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ret
;
;	Ktbjtos BIN szm konvertlsa 4-szmjegy DEC ASCII-ba
;
;	in: HL=binris szm  DE=hova
;
fk_dcon:push	de
	ld	de,0000		; DE-ben lesz a 4-jegy BCD szm
	ld	b,08		; 8-szor lpteti balra H-t
dcon0:	rlc	h
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon0
	ld	b,08		; 8-szor lpteti balra L-t
dcon1:	rlc	l
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon1
	pop	hl		; BCD szmjegyek konvertlsa ASCII-ba
	ex	de,hl
	ld	a,h
	call	bcon1
	ld	a,l
	call	bcon1
	ret
;
;	BIN->dtum konvertls
;
;	in: HL=dtum cme
;	    DE=ASCII szm els karakternek cme
;
fk_date:ld	b,0		; v
	ld	c,(hl)
	srl	c
	push	hl
	ld	hl,1980
	add	hl,bc
	call	fk_dcon
	ld	a,'.'
	ld	(de),a
	inc	de
	pop	hl
	ld	a,(hl)		; hnap
	dec	hl
	rra
	ld	a,(hl)
	rra
	rra
	rra
	rra
	rra
	and	0Fh
	call	fk_bcon
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	a,(hl)		; nap
	and	1Fh
	call	fk_bcon
	ret
;
;	BIN->id konvertls
;
;	in: HL=id cme
;	    DE=ASCII szm els karakternek cme
;
fk_time:ld	a,(hl)		; ra
	rra
	rra
	rra
	and	1Fh
	call	fk_bcon
	ld	a,':'
	ld	(de),a
	inc	de
	ld	a,(hl)		; perc
	dec	hl
	ld	b,(hl)
	rl	b
	rla
	rl	b
	rla
	rl	b
	rla
	and	3Fh
	call	fk_bcon
	dec	hl
	ret	
;
;
LKDKEZD	.equ	$
FPB	.equ	LKDKEZD			; FISH funkcihvs paramterblokkja (IX,HL,DE,BC)
FCB_0	.equ	FPB + 8
FCB_1	.equ	FCB_0 + 48
formpuff .equ	FCB_1 + 48
nevtbl	.equ	formpuff + 65
LKDVEG	.equ	nevtbl + nbj_max * 20
;
.end
